mod Ex06 logic: 'cl'

incl Mtex

incl Maux

loc rem 
  6. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 24.3.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [14:50,16:30,18:10]
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane kombinatorickym 
  funkciam na zoznamoch. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex06*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Combinatorial Functions over Lists.  \end 

rem 
  \para \bf  Suffix relation.  \end 
  \eq Suffix_zero_left
    Suffix(0,y) <-> y = 0
  \end
  \eq Suffix_pair_left
    Suffix((v,w),y) <-> y = v,w \/ Suffix(w,y)
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Generating suffixes.  \end 

fun Suffixes 
  Suffixes(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_suffixes
    y in Suffixes(x) <-> Suffix(x,y)
  \end

thm Spec_suffixes
  y in Suffixes(x) <-> Suffix(x,y)

rem 
  \para \bf  Auxiliary function.  \end 

fun/2 Mape 
  Mape(y,0) = 0
  Mape(y,v,w) = (y,v),Mape(y,w)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_mape
    z in Mape(y,x) <-> \e z1(z1 in x & z = y,z1)
  \end

thm Spec_mape
  z in Mape(y,x) <-> \e z1(z1 in x & z = y,z1)

rem 
  \para \bf  Prefix relation.  \end 
  \eq Prefix_zero_right
    Prefix(y,0) <-> y = 0
  \end
  \eq Prefix_pair_right
    Prefix(y,v,w) <-> y = 0 \/ \e z(Prefix(z,w) & y = v,z)
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Generating prefixes.  \end 

fun Prefixes 
  Prefixes(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_prefixes
    y in Prefixes(x) <-> Prefix(y,x)
  \end

thm Spec_prefixes
  y in Prefixes(x) <-> Prefix(y,x)

rem 
  \para \bf  Segments.  \end 
  \eq Segment_zero_right
    Segment(y,0) <-> y = 0
  \end
  \eq Segment_pair_right
    Segment(y,v,w) <-> \e z(Prefix(z,w) & y = v,z) \/ Segment(y,w)
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Generating segments.  \end 

fun Segments 
  Segments(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_segments
    y in Segments(x) <-> Segment(y,x)
  \end

thm Spec_segments
  y in Segments(x) <-> Segment(y,x)

rem 
  \para \bf  Subsequences.  \end 
  \eq Subsq_zero_right
    Subsq(y,0) <-> y = 0
  \end
  \eq Subsq_pair_right
    Subsq(y,v,w) <-> \e z(y = v,z & Subsq(z,w)) \/ Subsq(y,w)
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Generating subsequences.  \end 

fun Subsqs 
  Subsqs(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_subsqs
    y in Subsqs(x) <-> Subsq(y,x)
  \end

thm Spec_subsqs
  y in Subsqs(x) <-> Subsq(y,x)

rem 
  \para \bf  Insertion relation.  \end 
  \eq Inserted_zero_right
    Inserted(y,0,a) <-> y = a,0
  \end
  \eq Inserted_pair_right
    Inserted(y,(v,w),a) <-> y = a,v,w \/ \e z(Inserted(z,w,a) & y = v,z)
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Permutations.  \end 
  \eq Perm_zero_right
    Perm(y,0) <-> y = 0
  \end
  \eq Perm_pair_right
    Perm(y,v,w) <-> \e z(Perm(z,w) & Inserted(y,z,v))
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Generating permutations.  \end 

fun/2 Interleave 
  Interleave(y,x) = Foo

fun/2 Mapi 
  Mapi(y,x) = Foo

fun Perms 
  Perms(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_interleave
    z in Interleave(y,x) <-> Inserted(z,x,y)
  \end

thm Spec_interleave
  z in Interleave(y,x) <-> Inserted(z,x,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_mapi
    z in Mapi(y,x) <-> \e z1(z1 in x & Inserted(z,z1,y))
  \end

thm Spec_mapi
  z in Mapi(y,x) <-> \e z1(z1 in x & Inserted(z,z1,y))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_perms
    y in Perms(x) <-> Perm(y,x)
  \end

thm Spec_perms
  y in Perms(x) <-> Perm(y,x)

rem 
  \para \bf  List partitions.  \end 
  \eq Concp_zero_right
    Concp(y,0) <-> y = 0
  \end
  \eq Concp_pair_right
    Concp(y,v,w) <-> 
    \e z(Concp(z,w) & y = (v,0),z) \/ 
    \e z1\e z2(Concp((z1,z2),w) & y = (v,z1),z2)
  \end
  \para \it  [CL] Remark.  \end See the module \ft Maux \end. 

rem 
  \para \bf  Generating list partitions.  \end 

fun/2 Mapc1 
  Mapc1(y,x) = Foo

fun/2 Mapc2 
  Mapc2(y,x) = Foo

fun Concps 
  Concps(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_mapc1
    z in Mapc1(y,x) <-> \e z1(z1 in x & z = (y,0),z1)
  \end

thm Spec_mapc1
  z in Mapc1(y,x) <-> \e z1(z1 in x & z = (y,0),z1)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_mapc2
    z in Mapc2(y,x) <-> \e z1\e z2(z1,z2 in x & z = (y,z1),z2)
  \end

thm Spec_mapc2
  z in Mapc2(y,x) <-> \e z1\e z2(z1,z2 in x & z = (y,z1),z2)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_concps
    y in Concps(x) <-> Concp(y,x)
  \end

thm Spec_concps
  y in Concps(x) <-> Concp(y,x)

